local jkCornFarm = ...




jkCornFarm:registerAssetProcessor("models/corn.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})


jkCornFarm:registerAssetId("models/corn.fbx/Materials/corn", MOD_NS .. "TRANSPARENT_CORN")
jkCornFarm:override({
    Id = MOD_NS .. "TRANSPARENT_CORN",
    HasAlphaTest = true,
    BackFaceVisible = true,
    HasShadow = true,
})

local cornPartPath = "models/corn.fbx/Prefab/CornPart"
jkCornFarm:registerAssetId(cornPartPath, MOD_NS .. "CORN_PREFAB")

jkCornFarm:registerPrefabComponent(cornPartPath, {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_CORN",
    IsReplenishable = false,
    ResourceValue = 1,
    AvailableQuantity = 1,
    Radius = 1.3,
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})

jkCornFarm:registerPrefabComponent(cornPartPath, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 15.0 })
jkCornFarm:registerPrefabComponent(cornPartPath, { DataType = "COMP_CROP_FIELD_ELEMENT" })


jkCornFarm:registerAssetId("icons/corn.png", MOD_NS .. "ICON_CORN", "ATLAS_CELL")
jkCornFarm:register({
    DataType = "PLANTABLE",
    Id = MOD_NS .. "PLANTABLE_CORN",
    Name = MOD_NS .. "PLANTABLE_CORN_NAME",
    Icon = MOD_NS .. "ICON_CORN",
    PlantPrefab = MOD_NS .. "CORN_PREFAB",
    MinimumScale = 0.85,
    MaximumScale = 1.3
})


jkCornFarm:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_CORN",
	ResourceName = "RESOURCE_CORN_NAME",
	Icon = MOD_NS .. "ICON_CORN",
	ResourceTypeList = { "GRANARY", "RESOURCE_FOOD" },
	IsTradable = true,
	ResourceLayoutType = "BAGS",
	DisplayInInventory = true
})

-- Zone -------------------------------------------------------------------------------------
jkCornFarm:register({
    DataType = "ZONE",
    Id = MOD_NS .. "ZONE_CORN_FARM",
    Icon = MOD_NS .. "ICON_CORN",
    HoverIcon = MOD_NS .. "ICON_CORN",
    SelectionIcon = MOD_NS .. "ICON_CORN",
    Name = MOD_NS .. "ZONE_CORN_FARM_NAME",
    Description = MOD_NS .. "ZONE_CORN_FARM_DESC",
    Color = {2.5, 1.50, 1.20, 0.9},
    DesirabilityLayerToShow = "DESIRABILITY_FERTILITY"
})

-- Farm Field Config -------------------------------------------------------------------------------------
jkCornFarm:register({
    DataType = "FARM_FIELD_CONFIG",
    Id = MOD_NS .."FARM_FIELD_CONFIG_CORN_FARM",
    ZoneType = MOD_NS .."ZONE_CORN_FARM",
    PlantPrefab = MOD_NS .."CORN_PREFAB",
    HasPlantingCycle = true,
    IsScaling = true,
    StartScaleValue = 0.05,
    RowDistance = 1.9,
    ItemDistance = 1.2,
    RandomOrientation = {0, 360},
    RandomPositionOffset = {-.5, .5},
    SourceMaterial = MOD_NS .. "TRANSPARENT_CORN",
    GrowingMaterial = MOD_NS .. "TRANSPARENT_CORN",
    HarvestedMaterial = MOD_NS .. "TRANSPARENT_CORN",
    GrowingTextureList = {
    },
    HarvestingTextureList = {
    },
    AlphaTestThreshold = 0.5
})

