local jkCornFarm = ...

-- Growing Setup -------------------------------------------------------------------------------------
jkCornFarm:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_CORN_FARM_GROWING",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

-- Sowing Setup -------------------------------------------------------------------------------------
jkCornFarm:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_CORN_FARM_SOWING",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

-- Harvest Setup -------------------------------------------------------------------------------------
jkCornFarm:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_CORN_FARM_HARVEST",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

jkCornFarm:register({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = MOD_NS .. "BUILDING_FUNCTION_CORN_FARM",
    Name = "BUILDING_FUNCTION_CORN_FARM_NAME",
	WorkerCapacity = 3,
	-- InputInventoryCapacity = {{ Resource = "RESOURCE_CORN", Quantity = 200 }},
    RelatedJob = { 
        Job = "FARMER", 
        Behavior = "BEHAVIOR_FARMER"
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CORN", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_CORN", Quantity = 1 },
    },

    -- there is a max total cycle of 21 days so if you plan beyond that, it will be cut short
    SowingDurationPerc = {0, 5},
	GrowDuration = { 5, 9 }, 
	GrowWaitDuration = { 9, 10 },
	HarvestDuration = { 10, 19 },
	RestDuration = { 19, 21},

    QuantityToHarvestPerStep = 2,
	HarvestStepsCount = 3,
	ResourceValuePerGather = 1,

    QuantityToPlantPerStep = 1,
	PlantingStepsCount = 2,

    CropFieldConfig = MOD_NS .. "FARM_FIELD_CONFIG_CORN_FARM",
    GrowingSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_CORN_FARM_GROWING", 
    SowingSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_CORN_FARM_SOWING", 
    HarvestSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_CORN_FARM_HARVEST"
})


jkCornFarm:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = MOD_NS .. "BUILDING_FUNCTION_CORN_MILL",
    Name = "GRIND_CORN",
    WorkerCapacity = 2,
    RelatedJob = {
        Job = "MILLER",
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        {
            Resource = "RESOURCE_CORN",
            Quantity = 50
        }
    },
    ResourceListNeeded = {
        {
            Resource = "RESOURCE_CORN",
            Quantity = 1
        }
    },
    ResourceProduced = {
        {
            Resource = "FLOUR",
            Quantity = 1
        }
    }
})

jkCornFarm:override({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_WINDMILL",
    Name = "GRIND_WHEAT"
})

jkCornFarm:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = MOD_NS .. "BUILDING_FUNCTION_LIST_WINDMILL",
    AssetFunctionList = {
        "BUILDING_FUNCTION_WINDMILL",
        MOD_NS .. "BUILDING_FUNCTION_CORN_MILL",
    }
})

jkCornFarm:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = MOD_NS .. "FUNCTION_EXTENDED_WINDMILL",
    AuthorizedFunctionList = MOD_NS .. "BUILDING_FUNCTION_LIST_WINDMILL"
})

jkCornFarm:override({
	DataType = "BUILDING_PART",
    Id = "BUILDING_PART_WINDMILL",
    AssetBuildingFunction = MOD_NS .. "FUNCTION_EXTENDED_WINDMILL",
})
