local jkCornFarm = ...

jkCornFarm:registerAssetProcessor("models/corn.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

jkCornFarm:registerAssetId("models/corn.fbx/Materials/transparent_roof", MOD_NS .. "TRANSPARENT_FARM_ROOF")
jkCornFarm:override({
    Id = MOD_NS .. "TRANSPARENT_FARM_ROOF",
	HasTransparency = true,
	HasAlphaTest = true,
	HasShadow = true,
	BackFaceVisible = true
})

jkCornFarm:registerAssetId("models/corn.fbx/Prefab/BarnPart", MOD_NS .. "PREFAB_CORN_FARM")


jkCornFarm:registerPrefabComponent("models/corn.fbx/Prefab/BarnPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {4, 6}
})

jkCornFarm:registerPrefabComponent("models/corn.fbx/Prefab/BarnPart/Bucket", {
	DataType = "COMP_DIRT_CIRCLE",
	HardRadius = 0.7,
	SoftRadius = 1
})
jkCornFarm:registerPrefabComponent("models/corn.fbx/Prefab/BarnPart/Bucket", {
	DataType = "COMP_GROUNDED",
})
jkCornFarm:registerPrefabComponent("models/corn.fbx/Prefab/BarnPart/step_9/SackA", {
	DataType = "COMP_GROUNDED",
})

jkCornFarm:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "CORN_FARMM_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_CORN_FARM",
	AssetBuildingFunction = MOD_NS .. "BUILDING_FUNCTION_CORN_FARM",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {12, 6}, {-1, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_CORN_FARM"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD_COINS", Quantity = 100 }
		},
		UpkeepCost = {
			{ Resource = "GOLD_COINS", Quantity = 15 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 25 },
			{ Resource = "STONE", Quantity = 10 },
			{ Resource = "PLANK", Quantity = 10 }
		}
	}
})
